Subject: bug#43143: Building iwd on armhf triggers kernel panic

From: Vagrant Cascadian <[email-masked]>
Date: Mon, 21 Sep 2020 13:32:08 -0700

On 2020-09-02, Mark H Weaver wrote:
> Vagrant Cascadian <[email-masked]> writes:
>> On 2020-08-31, Vagrant Cascadian wrote:
>>> On 2020-08-31, Mark H. Weaver wrote:
>>>> Vagrant Cascadian <[email-masked]> writes:
>>>>> I've been getting kernel panics when i try to build iwd, a dependency of
>>>>> network-manager.
>>>>
>>>> Which kernel package variant(s) and version(s) have you seen panic when
>>>> building iwd?  What hardware?
>>>
>>> The hardware is veryron-speedy (a.k.a. asus chromebook c201p), with a
>>> rockchip rk3288 CPU and 4GB of ram; I might be able to test on
>>> additional hardware at some point (I've got a pretty old guix install on
>>> a novena, but don't recall if it was in good working order last time it
>>> booted).
>
> That message went on to say the following, although you omitted it here:
>
>>> [email-masked] 5.4.57, and presumably older versions as
>>> well, as I had commits in my local guix from mid June disabling iwd on
>>> network-manager.
>
>> Ok, managed to build iwd just fine on a novena imx6 platform, running
>> armhf on "linux-libre" 5.4.25 (haven't yet finished upgrading the
>> system).
>>
>> So it appears to potentially be hardware-specific? The imx6 vs. rk3288
>> are pretty different platforms;
>
> Based on what you wrote, it sounds like it could either be a
> hardware-specific problem, or else a kernel-configuration-specific
> problem, since you used radically different kernel configurations in
> these two cases.
>
> If I understand correctly, [email-masked]' is the variant
> that panicked on an rk3288, whereas the [email-masked]' variant with
> our hand-crafted default configuration worked on an imx6.
>
> I don't know whether it's possible to use precisely the same kernel
> configuration on these two systems.  Anyway, it would be helpful to
> retry the 'iwd' build on these two devices with kernel versions and
> configurations that are identical except for a minimal set of required
> differences.  That would help us narrow down the set of possible causes
> for this kernel panic.

Sorry for the late follow-up...

Using a more recent version of [email-masked], it failed to
build on both the veyron-speedy (rk3288) and the novena (imx6). It
doesn't necessarily *always* trigger a kernel panic; I haven't
identified which conditions trigger the kernel panic, but so far I've
only seen them on the veyron-speedy. I haven't seen it successfully
build with any recent linux-libre-arm-generic kernel, though recent
[email-masked] and @5.8 worked.

So it seems something in iwd needs specific kernel features in order to
build at all...

Not sure when I'll get a chance to debug further, but figured I'd update
about what I've tried so far.

live well,
  vagrant